#include <limits.h>
#include <math.h>
//#include <lib/libm/mathf.h>
#include <string.h>
#include <stdio.h>
#include "sigproc.h"

/* Originally written in C++ to work with OSSIE by Philip Balister
   Modified by S.M. Hasan for implementing in Blackfin BF537

*/
 	/*
	void main()
	{
		printf ("Using signal processing functions \n");
	
	}*/

	short phase_detect(short I_in, short Q_in, short I_nco, short Q_nco, float scale_factor)
 	
 	{
	
 	    float A, B; 
	    short out ; // temps for mixer output
	
	    //printf ("The value of I_in and Q_nco= %d, %d \n",I_in, Q_nco);
	    //printf ("The value of Q_in and I_nco= %d, %d \n",Q_in, I_nco);
	    
	    A = I_in * Q_nco;
 	    B = Q_in * I_nco;

	    //printf ("The value of A and B = %f, %f  \n",A, B);
 	
	    int out_i = (A - B)/scale_factor * SHRT_MAX;

	    //printf ("The value of (int) out_i = %d  \n", out_i);
 	
 	    if (out_i > SHRT_MAX)
		out = SHRT_MAX;
 	    else if (out_i < SHRT_MIN)
 	        out = SHRT_MIN;
	    else
	        out = (short) out_i;
		//printf ("The value of (short) out = %d  \n", out);
		
	    return out;
 	}

	short nco_i(short cv, int freq_index, int max_out, int max_freq_index)
 	{
 	    const double twopi = 6.2831853;
	    short cosine;
	   
 	    //int freq_index, max_out;  //	<<<===== added this
 	
	    // cv allowed to be -USHRT_MAX/4 < cv < USHRT_MAX/4
 	    // For large cv this gives four samples per cycle output
 	     	    //sine = (short) (max_out * sin(twopi * freq_index / max_freq_index));
 	    cosine = (short) (max_out * cos(twopi * freq_index / max_freq_index));
	   // printf("the value of sine is= %f \n", sine);
		
	    // return sine;
	    return cosine;
 	}

	short nco_q(short cv, int freq_index, int max_out, int max_freq_index)
 	{
 	    const double twopi = 6.2831853;
	    short sine;
	   
 	    //int freq_index, max_out;  //	<<<===== added this
 	
	    // cv allowed to be -USHRT_MAX/4 < cv < USHRT_MAX/4
 	    // For large cv this gives four samples per cycle output
 	   	
 	    sine = (short) (max_out * sin(twopi * freq_index / max_freq_index));
 	    //cosine = (short) (max_out * cos(twopi * freq_index / max_freq_index));
	   // printf("the value of sine is= %f \n", sine);
		
	     return sine;
	    // return cosine;
 	}

	short gain(float gain, short data_in) 	
 	{
 	
 	    short out;

	    float result = gain * data_in;
 	
 	    if (result > SHRT_MAX)
 	        out = SHRT_MAX;
 	    else if (result < SHRT_MIN)
 	        out = SHRT_MIN;
 	    else
 	        out = (short) result;
	  
	    return out;
 	}

/*
	short dc_block(short in)
	
 	{
 	
 	    int diff = in - prev_input;
 	    prev_input = in;
 	
 	    int out_val = diff + prev_output * forget_factor;
 	    prev_output = out_val;
 	
 	    out_val *= 10;
 	
 	    if (out_val > SHRT_MAX)
 	        out = SHRT_MAX;
 	    else if (out_val < SHRT_MIN)
 	        out = SHRT_MIN;
 	    else
 	        out = out_val;
	    
	    return out;
 	}

*/
